Search Results for

Show / Hide Table of Contents

# Class HexView

An hex viewer and editor View over a System.IO.Stream

##### Inheritance

System.Object
Responder
View
HexView

##### Implements

System.IDisposable
System.ComponentModel.ISupportInitializeNotification
System.ComponentModel.ISupportInitialize

##### Inherited Members

View.Added
View.Removed
View.Enter
View.Leave
View.MouseEnter
View.MouseLeave
View.MouseClick
View.HotKey
View.HotKeySpecifier
View.Shortcut
View.ShortcutTag
View.ShortcutAction
View.Data
View.Driver
View.Subviews
View.TabIndexes
View.TabIndex
View.TabStop
View.CanFocus
View.Id
View.IsCurrentTop
View.WantMousePositionReports
View.WantContinuousButtonPressed
View.LayoutStyle
View.Bounds
View.X
View.Y
View.Width
View.Height
View.SuperView
View.SetNeedsDisplay()
View.ClearLayoutNeeded()
View.SetNeedsDisplay(Rect)
View.SetChildNeedsDisplay()
View.Add(View)
View.Add(View[])
View.RemoveAll()
View.Remove(View)
View.BringSubviewToFront(View)
View.SendSubviewToBack(View)
View.SendSubviewBackwards(View)
View.BringSubviewForward(View)
View.Clear()
View.Clear(Rect)
View.ScreenToView(Int32, Int32)
View.ClipToBounds()
View.SetClip(Rect)
View.DrawFrame(Rect, Int32, Boolean)
View.DrawHotString(ustring, Attribute, Attribute)
View.DrawHotString(ustring, Boolean, ColorScheme)
View.Move(Int32, Int32)
View.HasFocus
View.OnAdded(View)
View.OnRemoved(View)
View.OnEnter(View)
View.OnLeave(View)
View.Focused
View.MostFocused
View.ColorScheme
View.AddRune(Int32, Int32, Rune)
View.ClearNeedsDisplay()
View.DrawContent
View.OnDrawContent(Rect)
View.SetFocus()
View.KeyPress
View.ProcessHotKey(KeyEvent)
View.ProcessColdKey(KeyEvent)
View.KeyDown
View.OnKeyDown(KeyEvent)
View.KeyUp
View.OnKeyUp(KeyEvent)
View.EnsureFocus()
View.FocusFirst()
View.FocusLast()
View.FocusPrev()
View.FocusNext()
View.LayoutStarted
View.LayoutComplete
View.Initialized
View.LayoutSubviews()
View.Text
View.AutoSize
View.TextAlignment
View.IsInitialized
View.ToString()
View.OnMouseEnter(MouseEvent)
View.OnMouseLeave(MouseEvent)
View.OnMouseEvent(MouseEvent)
View.OnMouseClick(View.MouseEventArgs)
View.Dispose(Boolean)
View.BeginInit()
View.EndInit()
View.Visible
View.SetWidth(Int32, Int32)
View.SetHeight(Int32, Int32)
Responder.MouseEvent(MouseEvent)
Responder.Dispose()
System.Object.Equals(System.Object)
System.Object.Equals(System.Object, System.Object)
System.Object.GetHashCode()
System.Object.GetType()
System.Object.MemberwiseClone()
System.Object.ReferenceEquals(System.Object, System.Object)

###### Namespace: Terminal.Gui

###### Assembly: Terminal.Gui.dll

##### Syntax

    public class HexView : View, IDisposable, ISupportInitializeNotification, ISupportInitialize

##### Remarks

HexView provides a hex editor on top of a seekable System.IO.Stream with the left side showing an hex dump of the values in the System.IO.Stream and the right side showing the contents (filtered to non-control sequence ASCII characters).

Users can switch from one side to the other by using the tab key.

To enable editing, set AllowEdits to true. When AllowEdits is true the user can make changes to the hexadecimal values of the System.IO.Stream. Any changes are tracked in the Edits property (a System.Collections.Generic.SortedDictionary`2) indicating the position where the changes were made and the new values. A convenience method, ApplyEdits() will apply the edits to the System.IO.Stream.

Control the first byte shown by setting the DisplayStart property to an offset in the stream.

### Constructors

#### HexView()

Initialzies a HexView class using Computed layout.

##### Declaration

    public HexView()

#### HexView(Stream)

Initialzies a HexView class using Computed layout.

##### Declaration

    public HexView(Stream source)

##### Parameters

Type | Name | Description
--- | --- | ---
System.IO.Stream | source | The System.IO.Stream to view and edit as hex, this System.IO.Stream must support seeking, or an exception will be thrown.

### Properties

#### AllowEdits

Gets or sets whether this HexView allow editing of the System.IO.Stream of the underlying System.IO.Stream.

##### Declaration

    public bool AllowEdits { get; set; }

##### Property Value

Type | Description
--- | ---
System.Boolean | `true` if allow edits; otherwise, `false`.

#### DesiredCursorVisibility

Get / Set the wished cursor when the field is focused

##### Declaration

    public CursorVisibility DesiredCursorVisibility { get; set; }

##### Property Value

Type | Description
--- | ---
CursorVisibility |

#### DisplayStart

Sets or gets the offset into the System.IO.Stream that will displayed at the top of the HexView

##### Declaration

    public long DisplayStart { get; set; }

##### Property Value

Type | Description
--- | ---
System.Int64 | The display start.

#### Edits

Gets a System.Collections.Generic.SortedDictionary`2 describing the edits done to the HexView. Each Key indicates an offset where an edit was made and the Value is the changed byte.

##### Declaration

    public IReadOnlyDictionary<long, byte> Edits { get; }

##### Property Value

Type | Description
--- | ---
System.Collections.Generic.IReadOnlyDictionary<System.Int64, System.Byte> | The edits.

#### Frame

##### Declaration

    public override Rect Frame { get; set; }

##### Property Value

Type | Description
--- | ---
Rect |

##### Overrides

View.Frame

#### Source

Sets or gets the System.IO.Stream the HexView is operating on; the stream must support seeking (System.IO.Stream.CanSeek == true).

##### Declaration

    public Stream Source { get; set; }

##### Property Value

Type | Description
--- | ---
System.IO.Stream | The source.

### Methods

#### ApplyEdits()

This method applies andy edits made to the System.IO.Stream and resets the contents of the Edits property

##### Declaration

    public void ApplyEdits()

#### PositionCursor()

##### Declaration

    public override void PositionCursor()

##### Overrides

View.PositionCursor()

#### ProcessKey(KeyEvent)

##### Declaration

    public override bool ProcessKey(KeyEvent keyEvent)

##### Parameters

Type | Name | Description
--- | --- | ---
KeyEvent | keyEvent |

##### Returns

Type | Description
--- | ---
System.Boolean |

##### Overrides

View.ProcessKey(KeyEvent)

#### Redraw(Rect)

##### Declaration

    public override void Redraw(Rect bounds)

##### Parameters

Type | Name | Description
--- | --- | ---
Rect | bounds |

##### Overrides

View.Redraw(Rect)

### Implements

System.IDisposable
System.ComponentModel.ISupportInitializeNotification
System.ComponentModel.ISupportInitialize